module CBopControlPanel
    use CBopControlPanelVariables
    implicit none    
    public    
    contains
    
    ! Input routines
    subroutine SetAnnularRegulatorSetControl(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularRegulatorSetControl
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularRegulatorSetControl' :: SetAnnularRegulatorSetControl
	    implicit none
	    real*8, intent(in) :: v
	    BopControlPanel%AnnularRegulatorSetControl = v
#ifdef deb
        print*, 'AnnularRegulatorSetControl=', BopControlPanel%AnnularRegulatorSetControl
#endif
    end subroutine

    subroutine SetAirMasterValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAirMasterValve
    !DEC$ ATTRIBUTES ALIAS: 'SetAirMasterValve' :: SetAirMasterValve
	    implicit none
	    real*8, intent(in) :: v
	    BopControlPanel%AirMasterValve = v
#ifdef deb
        print*, 'AirMasterValve=', BopControlPanel%AirMasterValve
#endif
    end subroutine

    subroutine SetByePassValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetByePassValve
    !DEC$ ATTRIBUTES ALIAS: 'SetByePassValve' :: SetByePassValve
	    implicit none
	    real*8, intent(in) :: v
	    BopControlPanel%ByePassValve = v
#ifdef deb
        print*, 'ByePassValve=', BopControlPanel%ByePassValve
#endif
    end subroutine

    subroutine SetAnnularValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularValve
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularValve' :: SetAnnularValve
	    implicit none
	    real*8, intent(in) :: v
	    BopControlPanel%AnnularValve = v
#ifdef deb
        print*, 'AnnularValve=', BopControlPanel%AnnularValve
#endif
    end subroutine

    subroutine SetUpperRamsValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetUpperRamsValve
    !DEC$ ATTRIBUTES ALIAS: 'SetUpperRamsValve' :: SetUpperRamsValve
	    implicit none
	    real*8, intent(in) :: v
	    BopControlPanel%UpperRamsValve = v
#ifdef deb
        print*, 'UpperRamsValve=', BopControlPanel%UpperRamsValve
#endif
    end subroutine

    subroutine SetMiddleRamsValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetMiddleRamsValve
    !DEC$ ATTRIBUTES ALIAS: 'SetMiddleRamsValve' :: SetMiddleRamsValve
	    implicit none
	    real*8, intent(in) :: v
	    BopControlPanel%MiddleRamsValve = v
#ifdef deb
        print*, 'MiddleRamsValve=', BopControlPanel%MiddleRamsValve
#endif
    end subroutine

    subroutine SetKillLineValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetKillLineValve
    !DEC$ ATTRIBUTES ALIAS: 'SetKillLineValve' :: SetKillLineValve
	    implicit none
	    real*8, intent(in) :: v
	    BopControlPanel%KillLineValve = v
#ifdef deb
        print*, 'KillLineValve=', BopControlPanel%KillLineValve
#endif
    end subroutine

    subroutine SetChokeLineValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetChokeLineValve
    !DEC$ ATTRIBUTES ALIAS: 'SetChokeLineValve' :: SetChokeLineValve
	    implicit none
	    real*8, intent(in) :: v
	    BopControlPanel%ChokeLineValve = v
#ifdef deb
        print*, 'ChokeLineValve=', BopControlPanel%ChokeLineValve
#endif
    end subroutine

    subroutine SetLowerRamsValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLowerRamsValve
    !DEC$ ATTRIBUTES ALIAS: 'SetLowerRamsValve' :: SetLowerRamsValve
	    implicit none
	    real*8, intent(in) :: v
	    BopControlPanel%LowerRamsValve = v
#ifdef deb
        print*, 'LowerRamsValve=', BopControlPanel%LowerRamsValve
#endif
    end subroutine


    ! Output routines
    real(8) function GetManifoldPressureGauge()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetManifoldPressureGauge
    !DEC$ ATTRIBUTES ALIAS: 'GetManifoldPressureGauge' :: GetManifoldPressureGauge
	    implicit none
	    GetManifoldPressureGauge = BopControlPanel%ManifoldPressureGauge
    end function

    real(8) function GetAirSupplyPressureGauge()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAirSupplyPressureGauge
    !DEC$ ATTRIBUTES ALIAS: 'GetAirSupplyPressureGauge' :: GetAirSupplyPressureGauge
	    implicit none
	    GetAirSupplyPressureGauge = BopControlPanel%AirSupplyPressureGauge
    end function

    real(8) function GetAccumulatorPressureGauge()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAccumulatorPressureGauge
    !DEC$ ATTRIBUTES ALIAS: 'GetAccumulatorPressureGauge' :: GetAccumulatorPressureGauge
	    implicit none
	    GetAccumulatorPressureGauge = BopControlPanel%AccumulatorPressureGauge
	    !GetAccumulatorPressureGauge = 2000.0d0
    end function

    real(8) function GetAnnularPressureGauge()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAnnularPressureGauge
    !DEC$ ATTRIBUTES ALIAS: 'GetAnnularPressureGauge' :: GetAnnularPressureGauge
	    implicit none
	    GetAnnularPressureGauge = BopControlPanel%AnnularPressureGauge
    end function

    integer function GetAnnularOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAnnularOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetAnnularOpenLED' :: GetAnnularOpenLED
	    implicit none
	    GetAnnularOpenLED = BopControlPanel%AnnularOpenLED
    end function

    integer function GetAnnularCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAnnularCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetAnnularCloseLED' :: GetAnnularCloseLED
	    implicit none
	    GetAnnularCloseLED = BopControlPanel%AnnularCloseLED
    end function

    integer function GetUpperRamsOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetUpperRamsOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetUpperRamsOpenLED' :: GetUpperRamsOpenLED
	    implicit none
	    GetUpperRamsOpenLED = BopControlPanel%UpperRamsOpenLED
    end function

    integer function GetUpperRamsCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetUpperRamsCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetUpperRamsCloseLED' :: GetUpperRamsCloseLED
	    implicit none
	    GetUpperRamsCloseLED = BopControlPanel%UpperRamsCloseLED
    end function

    integer function GetMiddleRamsOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetMiddleRamsOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetMiddleRamsOpenLED' :: GetMiddleRamsOpenLED
	    implicit none
	    GetMiddleRamsOpenLED = BopControlPanel%MiddleRamsOpenLED
    end function

    integer function GetMiddleRamsCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetMiddleRamsCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetMiddleRamsCloseLED' :: GetMiddleRamsCloseLED
	    implicit none
	    GetMiddleRamsCloseLED = BopControlPanel%MiddleRamsCloseLED
    end function

    integer function GetKillLineOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetKillLineOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetKillLineOpenLED' :: GetKillLineOpenLED
	    implicit none
	    GetKillLineOpenLED = BopControlPanel%KillLineOpenLED
    end function

    integer function GetKillLineCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetKillLineCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetKillLineCloseLED' :: GetKillLineCloseLED
	    implicit none
	    GetKillLineCloseLED = BopControlPanel%KillLineCloseLED
    end function

    integer function GetChokeLineOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetChokeLineOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetChokeLineOpenLED' :: GetChokeLineOpenLED
	    implicit none
	    GetChokeLineOpenLED = BopControlPanel%ChokeLineOpenLED
    end function

    integer function GetChokeLineCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetChokeLineCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetChokeLineCloseLED' :: GetChokeLineCloseLED
	    implicit none
	    GetChokeLineCloseLED = BopControlPanel%ChokeLineCloseLED
    end function

    integer function GetLowerRamsOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetLowerRamsOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetLowerRamsOpenLED' :: GetLowerRamsOpenLED
	    implicit none
	    GetLowerRamsOpenLED = BopControlPanel%LowerRamsOpenLED
    end function

    integer function GetLowerRamsCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetLowerRamsCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetLowerRamsCloseLED' :: GetLowerRamsCloseLED
	    implicit none
	    GetLowerRamsCloseLED = BopControlPanel%LowerRamsCloseLED
    end function

    real(8) function GetAnnularStatus()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAnnularStatus
    !DEC$ ATTRIBUTES ALIAS: 'GetAnnularStatus' :: GetAnnularStatus
	    implicit none
	    GetAnnularStatus = BopControlPanel%AnnularStatus
    end function

    real(8) function GetUpperRamsStatus()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetUpperRamsStatus
    !DEC$ ATTRIBUTES ALIAS: 'GetUpperRamsStatus' :: GetUpperRamsStatus
	    implicit none
	    GetUpperRamsStatus = BopControlPanel%UpperRamsStatus
    end function

    real(8) function GetMiddleRamsStatus()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetMiddleRamsStatus
    !DEC$ ATTRIBUTES ALIAS: 'GetMiddleRamsStatus' :: GetMiddleRamsStatus
	    implicit none
	    GetMiddleRamsStatus = BopControlPanel%MiddleRamsStatus
    end function

    real(8) function GetLowerRamsStatus()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetLowerRamsStatus
    !DEC$ ATTRIBUTES ALIAS: 'GetLowerRamsStatus' :: GetLowerRamsStatus
	    implicit none
	    GetLowerRamsStatus = BopControlPanel%LowerRamsStatus
    end function

 end module CBopControlPanel
