module PermissionsVariables
use CVoidEventHandlerCollection
    type::PermissionsType
        logical :: FillupHeadPermission = .false.
        type(VoidEventHandlerCollection) :: OnFillupHeadPermissionChange
        logical :: InstallFillupHeadPermission = .false.
        type(VoidEventHandlerCollection) :: OnInstallFillupHeadPermissionChange
        logical :: InstallMudBucketPermission = .false.
        type(VoidEventHandlerCollection) :: OnInstallMudBucketPermissionChange
        logical :: IrIbopPermission = .false.
        type(VoidEventHandlerCollection) :: OnIrIbopPermissionChange
        logical :: IrSafetyValvePermission = .false.
        type(VoidEventHandlerCollection) :: OnIrSafetyValvePermissionChange
        logical :: RemoveFillupHeadPermission = .false.
        type(VoidEventHandlerCollection) :: OnRemoveFillupHeadPermissionChange
        logical :: RemoveMudBucketPermission = .false.
        type(VoidEventHandlerCollection) :: OnRemoveMudBucketPermissionChange
        logical :: SwingDrillPermission = .false.
        type(VoidEventHandlerCollection) :: OnSwingDrillPermissionChange
        logical :: SwingOffPermission = .false.
        type(VoidEventHandlerCollection) :: OnSwingOffPermissionChange
        logical :: SwingTiltPermission = .false.
        type(VoidEventHandlerCollection) :: OnSwingTiltPermissionChange
    end type PermissionsType

    type(PermissionsType):: permissions

    contains

    subroutine Set_SwingTiltPermission(v)
        implicit none
        logical , intent(in) :: v
        #ifdef ExcludeExtraChanges
            if(permissions%SwingTiltPermission == v) return
        #endif
        permissions%SwingTiltPermission = v
        #ifdef deb
            print*, 'permissions%SwingTiltPermission=', permissions%SwingTiltPermission
        #endif
        call permissions%OnSwingTiltPermissionChange%RunAll()
    end subroutine

    logical function Get_SwingTiltPermission()
        implicit none
        Get_SwingTiltPermission = permissions%SwingTiltPermission
    end function

    subroutine Set_SwingOffPermission(v)
        implicit none
        logical , intent(in) :: v
        #ifdef ExcludeExtraChanges
            if(permissions%SwingOffPermission == v) return
        #endif
        permissions%SwingOffPermission = v
        #ifdef deb
            print*, 'permissions%SwingOffPermission=', permissions%SwingOffPermission
        #endif
        call permissions%OnSwingOffPermissionChange%RunAll()
    end subroutine

    logical function Get_SwingOffPermission()
        implicit none
        Get_SwingOffPermission = permissions%SwingOffPermission
    end function

    subroutine Set_SwingDrillPermission(v)
        implicit none
        logical , intent(in) :: v
        #ifdef ExcludeExtraChanges
            if(permissions%SwingDrillPermission == v) return
        #endif
        permissions%SwingDrillPermission = v
        #ifdef deb
            print*, 'permissions%SwingDrillPermission=', permissions%SwingDrillPermission
        #endif
        call permissions%OnSwingDrillPermissionChange%RunAll()
    end subroutine

    logical function Get_SwingDrillPermission()
        implicit none
        Get_SwingDrillPermission = permissions%SwingDrillPermission
    end function

    subroutine Set_RemoveMudBucketPermission(v)
        implicit none
        logical , intent(in) :: v
        #ifdef ExcludeExtraChanges
            if(permissions%RemoveMudBucketPermission == v) return
        #endif
        permissions%RemoveMudBucketPermission = v
        #ifdef deb
            print*, 'permissions%RemoveMudBucketPermission=', permissions%RemoveMudBucketPermission
        #endif
        call permissions%OnRemoveMudBucketPermissionChange%RunAll()
    end subroutine

    logical function Get_RemoveMudBucketPermission()
        implicit none
        Get_RemoveMudBucketPermission = permissions%RemoveMudBucketPermission
    end function


    subroutine Set_RemoveFillupHeadPermission(v)
        implicit none
        logical , intent(in) :: v
        #ifdef ExcludeExtraChanges
            if(permissions%RemoveFillupHeadPermission == v) return
        #endif
        permissions%RemoveFillupHeadPermission = v
        #ifdef deb
            print*, 'permissions%RemoveFillupHeadPermission=', permissions%RemoveFillupHeadPermission
        #endif
        call permissions%OnRemoveFillupHeadPermissionChange%RunAll()
    end subroutine

    logical function Get_RemoveFillupHeadPermission()
        implicit none
        Get_RemoveFillupHeadPermission = permissions%RemoveFillupHeadPermission
    end function

    subroutine Set_IrSafetyValvePermission(v)
        implicit none
        logical , intent(in) :: v
        #ifdef ExcludeExtraChanges
            if(permissions%IrSafetyValvePermission == v) return
        #endif
        permissions%IrSafetyValvePermission = v
        #ifdef deb
            print*, 'permissions%IrSafetyValvePermission=', permissions%IrSafetyValvePermission
        #endif
        call permissions%OnIrSafetyValvePermissionChange%RunAll()
    end subroutine

    logical function Get_IrSafetyValvePermission()
        implicit none
        Get_IrSafetyValvePermission = permissions%IrSafetyValvePermission
    end function

    subroutine Set_IrIbopPermission(v)
        implicit none
        logical , intent(in) :: v
        #ifdef ExcludeExtraChanges
            if(permissions%IrIbopPermission == v) return
        #endif
        permissions%IrIbopPermission = v
        #ifdef deb
            print*, 'permissions%IrIbopPermission=', permissions%IrIbopPermission
        #endif
        call permissions%OnIrIbopPermissionChange%RunAll()
    end subroutine

    logical function Get_IrIbopPermission()
        implicit none
        Get_IrIbopPermission = permissions%IrIbopPermission
    end function


    subroutine Set_InstallMudBucketPermission(v)
        implicit none
        logical , intent(in) :: v
        #ifdef ExcludeExtraChanges
            if(permissions%InstallMudBucketPermission == v) return
        #endif
        permissions%InstallMudBucketPermission = v
        #ifdef deb
            print*, 'permissions%InstallMudBucketPermission=', permissions%InstallMudBucketPermission
        #endif
        call permissions%OnInstallMudBucketPermissionChange%RunAll()
    end subroutine

    logical function Get_InstallMudBucketPermission()
        implicit none
        Get_InstallMudBucketPermission = permissions%InstallMudBucketPermission
    end function

    subroutine Set_InstallFillupHeadPermission(v)
        implicit none
        logical , intent(in) :: v
        #ifdef ExcludeExtraChanges
        if(permissions%InstallFillupHeadPermission == v) return
        #endif
        permissions%InstallFillupHeadPermission = v
        #ifdef deb
        print*, 'InstallFillupHeadPermission=', permissions%InstallFillupHeadPermission
        #endif
        call permissions%OnInstallFillupHeadPermissionChange%RunAll()
    end subroutine

    logical function Get_InstallFillupHeadPermission()
        implicit none
        Get_InstallFillupHeadPermission = permissions%InstallFillupHeadPermission
    end function

    subroutine Set_FillupHeadPermission(v)
        implicit none
        logical , intent(in) :: v
        #ifdef ExcludeExtraChanges
        if(permissions%FillupHeadPermission == v) return
        #endif
        permissions%FillupHeadPermission = v
        #ifdef deb
        print*, 'FillupHeadPermission=', permissions%FillupHeadPermission
        #endif
        call permissions%OnFillupHeadPermissionChange%RunAll()
    end subroutine

    logical function Get_FillupHeadPermission()
        implicit none
        Get_FillupHeadPermission = permissions%FillupHeadPermission
    end function

end module