module CGaugesProblems
	use CGaugesProblemsVariables
	implicit none    
	public 
    contains   	
    
    ! Input routines
    subroutine SetWeightIndicator(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetWeightIndicator
    !DEC$ ATTRIBUTES ALIAS: 'SetWeightIndicator' :: SetWeightIndicator
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%WeightIndicator = SetDue(v, ChangeWeightIndicator)
#ifdef deb
	    print*, 'WeightIndicator%ProblemType=', GaugesProblems%WeightIndicator%ProblemType
	    print*, 'WeightIndicator%StatusType=', GaugesProblems%WeightIndicator%StatusType
	    print*, 'WeightIndicator%Value=', GaugesProblems%WeightIndicator%Value
#endif
    end subroutine

    subroutine SetRotaryRpm(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRotaryRpm
    !DEC$ ATTRIBUTES ALIAS: 'SetRotaryRpm' :: SetRotaryRpm
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%RotaryRpm = SetDue(v, ChangeRotaryRpm)
#ifdef deb
	    print*, 'RotaryRpm%ProblemType=', GaugesProblems%RotaryRpm%ProblemType
	    print*, 'RotaryRpm%StatusType=', GaugesProblems%RotaryRpm%StatusType
	    print*, 'RotaryRpm%Value=', GaugesProblems%RotaryRpm%Value
#endif
    end subroutine

    subroutine SetRotaryTorque(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRotaryTorque
    !DEC$ ATTRIBUTES ALIAS: 'SetRotaryTorque' :: SetRotaryTorque
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%RotaryTorque = SetDue(v, ChangeRotaryTorque)
#ifdef deb
	    print*, 'RotaryTorque%ProblemType=', GaugesProblems%RotaryTorque%ProblemType
	    print*, 'RotaryTorque%StatusType=', GaugesProblems%RotaryTorque%StatusType
	    print*, 'RotaryTorque%Value=', GaugesProblems%RotaryTorque%Value
#endif
    end subroutine

    subroutine SetStandPipePressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStandPipePressure
    !DEC$ ATTRIBUTES ALIAS: 'SetStandPipePressure' :: SetStandPipePressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%StandPipePressure = SetDue(v, ChangeStandPipePressure)
#ifdef deb
	    print*, 'StandPipePressure%ProblemType=', GaugesProblems%StandPipePressure%ProblemType
	    print*, 'StandPipePressure%StatusType=', GaugesProblems%StandPipePressure%StatusType
	    print*, 'StandPipePressure%Value=', GaugesProblems%StandPipePressure%Value
#endif
    end subroutine

    subroutine SetCasingPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCasingPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetCasingPressure' :: SetCasingPressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%CasingPressure = SetDue(v, ChangeCasingPressure)
#ifdef deb
	    print*, 'CasingPressure%ProblemType=', GaugesProblems%CasingPressure%ProblemType
	    print*, 'CasingPressure%StatusType=', GaugesProblems%CasingPressure%StatusType
	    print*, 'CasingPressure%Value=', GaugesProblems%CasingPressure%Value
#endif
    end subroutine

    subroutine SetPump1Strokes(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPump1Strokes
    !DEC$ ATTRIBUTES ALIAS: 'SetPump1Strokes' :: SetPump1Strokes
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%Pump1Strokes = SetDue(v, ChangePump1Strokes)
#ifdef deb
	    print*, 'Pump1Strokes%ProblemType=', GaugesProblems%Pump1Strokes%ProblemType
	    print*, 'Pump1Strokes%StatusType=', GaugesProblems%Pump1Strokes%StatusType
	    print*, 'Pump1Strokes%Value=', GaugesProblems%Pump1Strokes%Value
#endif
    end subroutine

    subroutine SetPump2Strokes(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPump2Strokes
    !DEC$ ATTRIBUTES ALIAS: 'SetPump2Strokes' :: SetPump2Strokes
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%Pump2Strokes = SetDue(v, ChangePump2Strokes)
#ifdef deb
	    print*, 'Pump2Strokes%ProblemType=', GaugesProblems%Pump2Strokes%ProblemType
	    print*, 'Pump2Strokes%StatusType=', GaugesProblems%Pump2Strokes%StatusType
	    print*, 'Pump2Strokes%Value=', GaugesProblems%Pump2Strokes%Value
#endif
    end subroutine

    subroutine SetReturnLineTemperature(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetReturnLineTemperature
    !DEC$ ATTRIBUTES ALIAS: 'SetReturnLineTemperature' :: SetReturnLineTemperature
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%ReturnLineTemperature = SetDue(v, ChangeReturnLineTemperature)
#ifdef deb
	    print*, 'ReturnLineTemperature%ProblemType=', GaugesProblems%ReturnLineTemperature%ProblemType
	    print*, 'ReturnLineTemperature%StatusType=', GaugesProblems%ReturnLineTemperature%StatusType
	    print*, 'ReturnLineTemperature%Value=', GaugesProblems%ReturnLineTemperature%Value
#endif
    end subroutine

    subroutine SetTripTank(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetTripTank
    !DEC$ ATTRIBUTES ALIAS: 'SetTripTank' :: SetTripTank
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%TripTank = SetDue(v, ChangeTripTank)
#ifdef deb
	    print*, 'TripTank%ProblemType=', GaugesProblems%TripTank%ProblemType
	    print*, 'TripTank%StatusType=', GaugesProblems%TripTank%StatusType
	    print*, 'TripTank%Value=', GaugesProblems%TripTank%Value
#endif
    end subroutine

    subroutine SetPitGainLoss(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPitGainLoss
    !DEC$ ATTRIBUTES ALIAS: 'SetPitGainLoss' :: SetPitGainLoss
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%PitGainLoss = SetDue(v, ChangePitGainLoss)
#ifdef deb
	    print*, 'PitGainLoss%ProblemType=', GaugesProblems%PitGainLoss%ProblemType
	    print*, 'PitGainLoss%StatusType=', GaugesProblems%PitGainLoss%StatusType
	    print*, 'PitGainLoss%Value=', GaugesProblems%PitGainLoss%Value
#endif
    end subroutine

    subroutine SetMudTankVolume(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetMudTankVolume
    !DEC$ ATTRIBUTES ALIAS: 'SetMudTankVolume' :: SetMudTankVolume
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%MudTankVolume = SetDue(v, ChangeMudTankVolume)
#ifdef deb
	    print*, 'MudTankVolume%ProblemType=', GaugesProblems%MudTankVolume%ProblemType
	    print*, 'MudTankVolume%StatusType=', GaugesProblems%MudTankVolume%StatusType
	    print*, 'MudTankVolume%Value=', GaugesProblems%MudTankVolume%Value
#endif
    end subroutine

    subroutine SetReturnMudFlow(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetReturnMudFlow
    !DEC$ ATTRIBUTES ALIAS: 'SetReturnMudFlow' :: SetReturnMudFlow
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%ReturnMudFlow = SetDue(v, ChangeReturnMudFlow)
#ifdef deb
	    print*, 'ReturnMudFlow%ProblemType=', GaugesProblems%ReturnMudFlow%ProblemType
	    print*, 'ReturnMudFlow%StatusType=', GaugesProblems%ReturnMudFlow%StatusType
	    print*, 'ReturnMudFlow%Value=', GaugesProblems%ReturnMudFlow%Value
#endif
    end subroutine

    subroutine SetTorqueLimit(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetTorqueLimit
    !DEC$ ATTRIBUTES ALIAS: 'SetTorqueLimit' :: SetTorqueLimit
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%TorqueLimit = SetDue(v, ChangeTorqueLimit)
#ifdef deb
	    print*, 'TorqueLimit%ProblemType=', GaugesProblems%TorqueLimit%ProblemType
	    print*, 'TorqueLimit%StatusType=', GaugesProblems%TorqueLimit%StatusType
	    print*, 'TorqueLimit%Value=', GaugesProblems%TorqueLimit%Value
#endif
    end subroutine

    subroutine SetPowerLimit(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPowerLimit
    !DEC$ ATTRIBUTES ALIAS: 'SetPowerLimit' :: SetPowerLimit
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%PowerLimit = SetDue(v, ChangePowerLimit)
#ifdef deb
	    print*, 'PowerLimit%ProblemType=', GaugesProblems%PowerLimit%ProblemType
	    print*, 'PowerLimit%StatusType=', GaugesProblems%PowerLimit%StatusType
	    print*, 'PowerLimit%Value=', GaugesProblems%PowerLimit%Value
#endif
    end subroutine

    subroutine SetAccumulatorPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAccumulatorPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetAccumulatorPressure' :: SetAccumulatorPressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%AccumulatorPressure = SetDue(v, ChangeAccumulatorPressure)
#ifdef deb
	    print*, 'AccumulatorPressure%ProblemType=', GaugesProblems%AccumulatorPressure%ProblemType
	    print*, 'AccumulatorPressure%StatusType=', GaugesProblems%AccumulatorPressure%StatusType
	    print*, 'AccumulatorPressure%Value=', GaugesProblems%AccumulatorPressure%Value
#endif
    end subroutine

    subroutine SetManifoldPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetManifoldPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetManifoldPressure' :: SetManifoldPressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%ManifoldPressure = SetDue(v, ChangeManifoldPressure)
#ifdef deb
	    print*, 'ManifoldPressure%ProblemType=', GaugesProblems%ManifoldPressure%ProblemType
	    print*, 'ManifoldPressure%StatusType=', GaugesProblems%ManifoldPressure%StatusType
	    print*, 'ManifoldPressure%Value=', GaugesProblems%ManifoldPressure%Value
#endif
    end subroutine

    subroutine SetAnnularPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularPressure' :: SetAnnularPressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%AnnularPressure = SetDue(v, ChangeAnnularPressure)
#ifdef deb
	    print*, 'AnnularPressure%ProblemType=', GaugesProblems%AnnularPressure%ProblemType
	    print*, 'AnnularPressure%StatusType=', GaugesProblems%AnnularPressure%StatusType
	    print*, 'AnnularPressure%Value=', GaugesProblems%AnnularPressure%Value
#endif
    end subroutine

    subroutine SetRigAirPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRigAirPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetRigAirPressure' :: SetRigAirPressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%RigAirPressure = SetDue(v, ChangeRigAirPressure)
#ifdef deb
	    print*, 'RigAirPressure%ProblemType=', GaugesProblems%RigAirPressure%ProblemType
	    print*, 'RigAirPressure%StatusType=', GaugesProblems%RigAirPressure%StatusType
	    print*, 'RigAirPressure%Value=', GaugesProblems%RigAirPressure%Value
#endif
    end subroutine

    subroutine SetStandPipe1(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStandPipe1
    !DEC$ ATTRIBUTES ALIAS: 'SetStandPipe1' :: SetStandPipe1
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%StandPipe1 = SetDue(v, ChangeStandPipe1)
#ifdef deb
	    print*, 'StandPipe1%ProblemType=', GaugesProblems%StandPipe1%ProblemType
	    print*, 'StandPipe1%StatusType=', GaugesProblems%StandPipe1%StatusType
	    print*, 'StandPipe1%Value=', GaugesProblems%StandPipe1%Value
#endif
    end subroutine

    subroutine SetStandPipe2(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStandPipe2
    !DEC$ ATTRIBUTES ALIAS: 'SetStandPipe2' :: SetStandPipe2
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%StandPipe2 = SetDue(v, ChangeStandPipe2)
#ifdef deb
	    print*, 'StandPipe2%ProblemType=', GaugesProblems%StandPipe2%ProblemType
	    print*, 'StandPipe2%StatusType=', GaugesProblems%StandPipe2%StatusType
	    print*, 'StandPipe2%Value=', GaugesProblems%StandPipe2%Value
#endif
    end subroutine

    subroutine SetDrillPipePressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetDrillPipePressure
    !DEC$ ATTRIBUTES ALIAS: 'SetDrillPipePressure' :: SetDrillPipePressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%DrillPipePressure = SetDue(v, ChangeDrillPipePressure)
#ifdef deb
	    print*, 'DrillPipePressure%ProblemType=', GaugesProblems%DrillPipePressure%ProblemType
	    print*, 'DrillPipePressure%StatusType=', GaugesProblems%DrillPipePressure%StatusType
	    print*, 'DrillPipePressure%Value=', GaugesProblems%DrillPipePressure%Value
#endif
    end subroutine

    subroutine SetChokePosition(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetChokePosition
    !DEC$ ATTRIBUTES ALIAS: 'SetChokePosition' :: SetChokePosition
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%ChokePosition = SetDue(v, ChangeChokePosition)
#ifdef deb
	    print*, 'ChokePosition%ProblemType=', GaugesProblems%ChokePosition%ProblemType
	    print*, 'ChokePosition%StatusType=', GaugesProblems%ChokePosition%StatusType
	    print*, 'ChokePosition%Value=', GaugesProblems%ChokePosition%Value
#endif
    end subroutine

    subroutine SetCasingPressure2(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCasingPressure2
    !DEC$ ATTRIBUTES ALIAS: 'SetCasingPressure2' :: SetCasingPressure2
	    implicit none
	    type(CProblem), intent(in) :: v
	    GaugesProblems%CasingPressure2 = SetDue(v, ChangeCasingPressure2)
#ifdef deb
	    print*, 'CasingPressure2%ProblemType=', GaugesProblems%CasingPressure2%ProblemType
	    print*, 'CasingPressure2%StatusType=', GaugesProblems%CasingPressure2%StatusType
	    print*, 'CasingPressure2%Value=', GaugesProblems%CasingPressure2%Value
#endif
    end subroutine

end module CGaugesProblems