MODULE Pumps_VARIABLES
    
    IMPLICIT NONE
    PUBLIC
    REAL , PARAMETER :: pi=3.14159265e0
    Logical :: Pumps_IsStopped
    Type, public:: Pumps_Type
        REAL :: Total_Pump_GPM, Total_Pump_SPM, Total_Stroke_Counter_For_Plot
    end Type Pumps_Type
    Type(Pumps_Type)::total_pumps
    
    
    
!****************************************************************************************************    
!**************** Define PUMP Array ************************************************************
    TYPE, PUBLIC :: Pump_Var
    
!*****  Pump_VARIABLES  ***************************
    INTEGER :: AssignmentSwitchh, Switch, K_throttle
    INTEGER :: PowerFailMalf , BlowPopOffMalf , SPMGaugeMalf , Failure

    REAL :: Throttle, RateChange
    REAL :: Stroke_Length, Piston_Area, Piston_Diameter, Inertia_Moment
    REAL :: Mech_Efficiency, Vol_Efficiency, Trans_Ratio
    REAL :: StandPipe_Pressure , Max_Pressure
    REAL :: Torque, Speed, N_new, N_old, MaxSPM
    REAL :: Flow_Rate, Hydraulic_HorsePower, Max_Horsepower, FlowRatePerSTK, Max_FlowRate
    REAL :: simulation_time, time_step
    
    REAL(8) :: START_TIME, END_TIME
    INTEGER :: INT_CPU_TIME, Dt_ref
    
!*************  Sound_VARIABLES  **********************
    INTEGER :: SoundSPM
    Logical :: SoundBlower
    
    END TYPE Pump_Var

    TYPE(Pump_Var), DIMENSION(1:3) :: PUMP
!***********************************************************************************************   
!***********************************************************************************************
    
END MODULE Pumps_VARIABLES